/* 
WARNING !!!!!!!!!!!!!!!!
RGB32, YUYV and UYVY struct must be compiled with alined data on 1 byte.
*/ 

#pragma pack(push,1)		// Compiler option, alined data on 1 byte, equal /Zp1

typedef struct _RGB32
{
	unsigned char b;
	unsigned char g;
	unsigned char r;
	unsigned char alpha;
} RGB32;

typedef struct _YUYV
{
	unsigned char y1;
	unsigned char u;
	unsigned char y2;
	unsigned char v;
} YUYV;

typedef struct _UYVY
{
	unsigned char u;
	unsigned char y1;
	unsigned char v;
	unsigned char y2;
} UYVY;

#pragma pack(pop)		// Put back project alined data setting

typedef struct _Image_Data
{
	uint8 video_mode,src_video_mode,dst_video_mode;
	const void *src_plane0,*src_plane1,*src_plane2;
	sint32 src_w0,src_w1,src_w2;
	sint32 src_h0,src_h1,src_h2;
	ptrdiff_t src_pitch0,src_pitch1,src_pitch2;
	ptrdiff_t src_modulo0,src_modulo1,src_modulo2;
	ptrdiff_t src_size0,src_size1,src_size2;
	void *dst_plane0,*dst_plane1,*dst_plane2;
	sint32 dst_w0,dst_w1,dst_w2;
	sint32 dst_h0,dst_h1,dst_h2;
	ptrdiff_t dst_pitch0,dst_pitch1,dst_pitch2;
	ptrdiff_t dst_modulo0,dst_modulo1,dst_modulo2;
	ptrdiff_t dst_size0,dst_size1,dst_size2;
} Image_Data;


#define myfree(ptr) if (ptr!=NULL) { free(ptr); ptr=NULL;}